package com.template.controller;


import com.template.api.SmartBuildMeterControllerAPI;
import com.template.common.utils.paramUtils;
import com.template.model.pojo.SmartBuild;
import com.template.model.pojo.SmartBuildMeter;
import com.template.model.result.CommonResult;
import com.template.model.result.PageUtils;
import com.template.services.SmartBuildMeterService;
import com.template.services.SmartBuildService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-12-04
 */
@RestController
public class SmartBuildMeterController implements SmartBuildMeterControllerAPI {

    @Autowired
    private SmartBuildMeterService smartBuildMeterService;

    /**
     * 新增楼栋水电表
     * @param smartApply 楼栋水电表数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult insertSmartBuildMeter(SmartBuildMeter smartApply, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartBuildMeterService.insertSmartBuildMeter(smartApply);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新楼栋水电表
     * @param sa 楼栋水电表数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult updateSmartBuildMeterById(SmartBuildMeter sa, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartBuildMeterService.updateSmartBuildMeter(sa);
        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 楼栋水电表分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageSmartBuildMeters(int currentPage, int pageCount, String name) {
        PageUtils<SmartBuildMeter> result = smartBuildMeterService.queryPageSmartBuildMeters(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }


    @Override
    public CommonResult deleteSmartBuildMeterById(int id) {

        SmartBuildMeter data = smartBuildMeterService.getSmartById(id);

        if(data == null){
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = smartBuildMeterService.deleteSmartBuildMeterById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

